const CONSTANTS = {
    ACTIONS: {
        BACK_TO_HINT: 'back_to_hint',
        BLOCK_UI: 'block_ui',
        CHECK_IS_AUTOMATION_BROWSER: 'check_is_automation_browser',
        CHECK_IS_FRAME: 'check_is_frame',
        CHECK_IS_FRAMESET: 'check_is_frameset',
        CLOSE_DIALOG: 'close_dialog',
        CLOSE_WELCOME_DIALOG: 'close_welcome_dialog',
        ELEMENT_CAPTURED: 'element_captured',
        FOCUS_DIALOG: 'focus_dialog',
        GENERATE_SMART_XPATH: 'generate_smart_xpath',
        GENERATION_FINISHED: 'generation_finished',
        GET_PRECISE_XPATH_FOR_FRAME: 'get_precise_xpath_for_frame',
        HIDE_DIALOG: 'hide_dialog',
        HINT_DIALOG_RESULT: 'hint_dialog_result',
        LOCATOR_DIALOG_RESULT: 'locator_dialog_result',
        OPEN_DIALOG: 'open_dialog',
        RESET_CAPTURING: 'reset_capturing',
        SEND_NOTIFICATION: 'send_notification',
        SHOW_ALERT: 'show_alert',
        SHOW_DIALOG: 'show_dialog',
        SKIP: 'skip',
        START_CAPTURING: 'start_capturing',
        STOP_CAPTURING: 'stop_capturing',
        SYNC_DIALOG_SIZE: 'sync_dialog_size',
        TEST: 'test',
        TEST_CSS: 'test_css',
        TEST_CSS_FINISHED: 'test_css_finished',
        TEST_XPATH: 'test_xpath',
        TEST_XPATH_FINISHED: 'test_xpath_finished',
        XPATH_CAN_NOT_BE_GENERATED: 'xpath_can_not_be_generated',
    },
    ATTRIBUTES: {
        CLASS: 'class',
        ID: 'id',
        NAME: 'name',
        SRC: 'src',
        STYLE: 'style',
        OUTLINE: 'outline',
        READONLY: 'readonly',
        SANDBOX: 'sandbox',
        TITLE: 'title',
    },
    ATTRIBUTE_SRC_VALUE_SRCDOC: 'about:srcdoc',
    CLICKABLE_ELEMENT_TAGS: [
        'a',
        'input',
        'button'
    ],
    CSS: {
        SHADOW_PSEUDO: '::shadow',
        SHADOW_PSEUDO_CLOSED: '::shadow-closed',
    },
    CSS_HELPERS: {
        NTH_OF_TYPE: ':nth-of-type(${VALUE})',
        NTH_PATTERN: ':nth-of-type\\((\\d+)\\)',
    },
    DIALOG_ELEMENTS: {
        HANDLE: {
            LABEL: 'Handle',
        },
        IFRAME: {
            LABEL: 'Frame',
        }
    },
    DIALOG_FRAME_OPTIONS: {
        HINT: {
            TYPE: 'Hint',
            CLASS_NAME: 's7-hint',
            URL: '/js/frames/hint/hint.html',
            WIDTH: 370
        },
        LOCATOR: {
            TYPE: 'Locator',
            CLASS_NAME: 's7-locator',
            URL: '/js/frames/locator/locator.html',
            WIDTH: 705
        }
    },
    DIALOG_OPTIONS: {
        HINT: {
            URL: '/js/dialogs/hint/hint.html',
            WIDTH: 370,
            HEIGHT: 185,
            ADVANCED_HEIGHT: 285
        },
        LOCATOR: {
            URL: '/js/dialogs/locator/locator.html',
            WIDTH: 705,
            HEIGHT: 260,
            ADVANCED_HEIGHT: 335
        },
        WELCOME: {
            URL: 'js/dialogs/welcome/welcome.html',
            WIDTH: 375,
            HEIGHT: 180
        },
    },
    DRAGGABLE_OPTIONS: {
        handle: '.handle',
        cursor: 'move',
        delay: 100,
        distance: 1,
        opacity: 0.9,
        addClass: false,
        iframeFix: true,
        containment: 'window',
        scroll: false
    },
    ERROR_MESSAGES: {
        CSS_CAN_NOT_BE_GENERATED: 'CSS Selector could not be generated',
        CSS_RETURNS_SEVERAL_ELEMENTS: 'CSS returns several elements',
        CUSTOM_CSS_SELECTOR_WILL_BE_GENERATED: 'The target element is inside the Shadow DOM, a custom CSS Selector will be generated instead of XPath',
        ELEMENT_NOT_FOUND_CSS: 'No element was found with the provided CSS Selector',
        ELEMENT_NOT_FOUND_XPATH: 'No element was found with the provided XPath',
        INVALID_CSS: 'Error while testing CSS Selector: ',
        INVALID_OR_UNSUPPORTED_XPATH: 'CSS Generation Error: Invalid or unsupported XPath',
        INVALID_OR_UNSUPPORTED_XPATH_ATTRIBUTE: 'CSS Generation Error: Invalid or unsupported XPath attribute: ',
        INVALID_XPATH: 'Invalid XPath',
        MISSING_XPATH_EXPRESSION: 'CSS Generation Error: Missing XPath expression',
        SHADOW_CSS_CANNOT_END_ON_A_SHADOW_ROOT: 'A Shadow DOM CSS selector cannot end on a shadow root element. Please end the selector with an element inside the shadow root',
        UNABLE_TO_GENERATE_XPATH_FOR_FRAME: 'XPath could not be generated for frame',
        XPATH_AND_CSS_CAN_NOT_BE_GENERATED: 'The target element is inside a closed shadow DOM, neither the CSS selector nor the XPath will be generated',
        XPATH_CAN_NOT_BE_GENERATED: 'XPath could not be generated, please try different hint',
        XPATH_RETURNS_SEVERAL_ELEMENTS: 'XPath returns several elements',
    },
    EVENTS: {
        DOM: {
            CLICK: 'click',
            INPUT: 'input',
            KEY_DOWN: 'keydown',
            KEY_UP: 'keyup',
            SUBMIT: 'submit',
            BLUR: 'blur',
        },
        WINDOW: {
            MESSAGE: 'message',
            DOM_CONTENT_LOADED: 'DOMContentLoaded',
        },
    },
    EXTENSION_NAME: 'Subject7 Gutenberg',
    EXTERNAL_EXTENSIONS: {
        RECORDER: {
            ID: 'ccjpbnplcmmlkogjfpamhdpjhamhckac',
            ID_FROM_STORE: 'ajdomjioajflpgeppddeonfgnpjefinl',
            REASON: 'checkStatus',
        },
    },
    HINT: {
        ATTRIBUTES_LIST: [
            'value',
            'placeholder',
            'name',
            'title',
            'for'
        ]
    },
    KEEP_ALIVE_CHECK_TIMEOUT: 29e3,
    MESSAGE_SENDERS: {
        CHILD_WINDOW: 'subject7-gutenberg-child-window',
        S7_OPEN_HINT_WINDOW: 'subject7-gutenberg-open-hint-window',
        S7_OPEN_LOCATOR_WINDOW: 'subject7-gutenberg-open-locator-window',
    },
    MESSAGING_PORT: 'CS2SW',
    NOTIFICATION_IDS: {
        BACKGROUND: 'GUTENBERG_S7_BACKGROUND_SCRIPT_NOTIFICATION',
        CONTENT: 'GUTENBERG_S7_CONTENT_SCRIPT_NOTIFICATION',
        LOCATOR: 'GUTENBERG_S7_LOCATOR_NOTIFICATION',
        OPTIONS: 'GUTENBERG_S7_OPTIONS_NOTIFICATION',
    },
    NOTIFICATION_MESSAGES: {
        CONFIGURATION_SAVED: 'Configuration is saved',
        INTERNAL_SERVER_ERROR: 'Internal server error',
        LOCATOR_SAVED: 'Locator is saved',
        REFRESH_PAGE: 'Please browse to a URL or refresh current page',
        SETTINGS_NOT_FOUND: 'No settings were found for Gutenberg',
        CONNECTION_TEST_SUCCESSFUL: 'Connection test successful',
        CANNOT_ENABLE_GUTENBERG: 'Cannot enable Gutenberg because Recorder is active',
        GUTENBERG_IS_INACTIVE: 'Gutenberg is inactive because Recorder is active',
        UNEXPECTED_RESPONSE: 'You have got unexpected response from server. Please contact administrator\nResponse code: $STATUS\nResponse body: $DATA',
        WRONG_CREDENTIALS: 'Wrong credentials. Please check username and password',
        WRONG_CREDENTIALS_API_KEY: 'Wrong credentials. Please check API key',
        WRONG_HOST: 'Please check Subject7 host in the Settings page',
        WRONG_HOST_CONFIGURATION: 'Something went wrong.\nPlease check Subject7 host on a settings page.\nThen check did you allowed the plugin read and change site data.\n1. Right-click on the plugin icon.\n2. This can read and change site data.\n3. Select \'On all sites\'\nIf it doesn\'t help, please contact the administrator',
    },
    NOTIFICATION_ICON_URL: '/img/app-icon128x128.png',
    OPEN_DIALOG_DELAY: {
        HINT: 200,
        LOCATOR: 200
    },
    REPLACE_STRINGS: {
        HINT: '${HINT}',
        VALUE: '${VALUE}',
    },
    TAGS: {
        HTML: 'html',
        BODY: 'body',
        DIV: 'div',
        IFRAME: 'iframe',
        INPUT: 'input',
        SELECT: 'select',
        TEXTAREA: 'textarea',
        IMG: 'img',
        LABEL: 'label',
        RECORDER_BLOCK: 'recorderblock',
        FRAMESET: 'FRAMESET',
        SLOT: 'slot',
        SPAN: 'span',
    },
    TEST_TYPES: {
        CSS: 'CSS',
        XPATH: 'XPath',
    },
    XPATH_AXES: {
        ANCESTOR: 'ancestor',
        DESCENDANT: 'descendant',
    },
    XPATH_HELPERS: {
        START_XPATH: '//',
        AXES_NODE_DIVIDER: '::',
        NODE_DIVIDER: '/',
    }
};
